#!/usr/bin/perl -w
#
# MicroPlan2002Υɥѥ
#
# (c) FukTommy<fuktommy@my.tramonline.net>
#
# 2002/05/20	ver.-.-.-	ȡʥ
# 2002/05/22	ver.-.-.-	ñʼβϤ
# 2002/05/23	ver.-.-.-	˹碌ƽľ
# 2002/05/24	ver.-.-.-	ؿ³ʸμ
# 2002/05/25	ver.-.-.-	ȹߴؿ³μ
# 2002/05/26	ver.0.0.1	
# 2002/05/26	ver.0.0.2	repeat-untilνλν
# 2002/05/27	ver.0.0.3	putΰ˳̤Ȥʤäν
#

# ѿ
@input	= ();	# 
@token	= ();	# Ϥȡˤ
@stack	= ();	# å
@code	= ();	# Rx
%global	= ();	# ǡΰ̾ɽ
$global	= 0;	# ǡΰΥ

@allOp = ("eq", "ne", "gt", "lt", "add", "sub", "or",
				"mul", "div", "mod", "and", "not");

# ν
if (grep $_ eq "--help", @ARGV) {
	exec "cat $0";
} elsif (@ARGV == 0) {
	@input = <STDIN>;
} elsif (@ARGV == 1) {
	open IN, $ARGV[0];
	@input = <IN>;
	close IN;
} else {
	die "usage: $0 [Qx-code-file]\n";
}

# 
@char = split //, join("", @input);
push @stack, "";
$index = 1;
$t = "";
foreach (@char) {
	if ($_ eq "\n") {				# 
		if ($t ne "") {
			push @token, $t;
			$t = "";
		}
		push @token, "\n";
		$index++;

	} elsif (($stack[-1] eq '"')&&($stack[-2] eq "'")) {# "ˤ륨
		pop @stack;
		$t .= $_;

	} elsif ($stack[-1] eq '"') {			# ʸ
		push @token, unpack("C", $_);
		pop @stack;

	} elsif ($_ eq '"') {			# פʸ
		push @stack, '"';

	} elsif (($_ eq "'") && ($stack[-1] ne "'")) {	# ʸ󳫻
		push @stack, "'";
		$t .= "'";

	} elsif (($_ ne "'") && ($stack[-1] eq "'")) {	# ʸ
		$t .= $_;

	} elsif (($_ eq "'") && ($stack[-1] eq "'")) {	# ʸλ
		$t .= "'";
		pop @stack;
		push @token, $t;
		$t = "";

	} elsif (($_ eq "%") && ($stack[-1] ne "%")) {	# ȳ
		push @stack, "%";

	} elsif (($_ ne "%") && ($stack[-1] eq "%")) {	# 
		# do nothing

	} elsif (($_ eq "%") && ($stack[-1] eq "%")) {	# Ƚλ
		pop @stack;

	} elsif (/\s/) {				# 
		if ($t ne "") {
			push @token, $t;
			$t = "";
		}

	} elsif (/[-,;:#<>+*()=\[\].]/) {		# 黻Ҥʤɤε
		if ($t ne "") {
			push @token, $t;
			$t = "";
		}
		push @token, $_;

	} elsif (/[A-Za-z0-9\$]/) {			# ѿ
		$t .= $_;

	} else {					# 顼
		warn "Bad charactor '$_' at line $index.\n";
		warn $input[$index-1];
		exit 1;
	}
}

# 16ʿ
$index = 1;
foreach (@token) {
	if (/^\$([A-Fa-f0-9]+)$/) {
		$_ = hex $1;
	} elsif (/\$/) {
		warn "Bad charactor '$_' at line $index.\n";
		warn $input[$index-1];
		exit 1;
	} elsif ($_ eq "\n") {
		$index++;
	}
}

# ñ黻
for ($i=1; $i<@token; $i++) {
	if (($token[$i] =~ /^(\+|or)$/)&&($token[$i-1] =~ /^[=([]$/)) {
		@token = (@token[0..$i-1], @token[$i+1..$#token]);
	} elsif (($token[$i] eq "=")&&($token[$i-1] =~ /^[=([]$/)) {
		$token[$i] = "--";
	}
}

# ʸ
push @stack, "";
$index = 1;
$c = 0;
for ($i=0; $i<@token; $i++) {
	local $_ = $token[$i];
	my $st = $stack[-1];
	if ($_ eq "\n") {				# 
		$index++;

	} elsif ((/^(proc|func)$/)&&($st eq "")) {	# ؿ³
		push @stack, "\%$_";
		%name = %global;
		$local = 1;
		$argsize = 0;
		push @stack, "\%arg";

	} elsif ((/^(var|array)$/)&&($st =~ /^(|\%proc|\%func)$/)) {# ѿ
		push @stack, $_;

	} elsif ((/^[A-Za-z]/)&&($st eq "\%arg")) {	# ؿ³̾
		$code[$c++] = "_def\t$_";
		$code[$c++] = $stack[-2];

	} elsif ((/^(array|,|;|)$/)&&($st eq "(")	# γ̤
					&&($stack[-2] eq "\%arg")) {
		# do nothing				

	} elsif ((/^[A-Za-z]/)&&($st eq "(")&&($stack[-2] eq "\%arg")) {
		$name{$_} = "l[$local]";		# 
		$local++;
		$argsize++;

	} elsif (($_ eq ";")&&($st eq "\%arg")) {	# 
		pop @stack;

	} elsif (/^(var|array)$/) {			# ѿ
		synerr();

	} elsif (($_ eq ",")&&($st =~ /^(var|array)$/)) { # Υ
		# do nothing

	} elsif (($_ eq ";")&&($st =~ /^(begin)$/)) {	# ʸνλ
		# do nothing;

	} elsif (($_ eq ";")&&($st eq "var")) {		# ѿλ
		pop @stack;
		if ($stack[-1] eq "") {
			%name = %global;
		}

	} elsif (($_ eq ";")&&($st eq "array")) {	# λ
		$code[$c++] = "_endinit";
		%name = %global;
		pop @stack;

	} elsif ((/^[A-Za-z]/)&&($st eq "var")) {	# ѿ
		if ($stack[-2] eq "") {
			$global{$_} = "g[$global]";
			$global++;
		} elsif ($stack[-2] =~ /^\%(proc|func)$/) {
			$name{$_} = "l[$local]";
			$local++;
		} else {
			synerr();
		}

	} elsif ((/^[A-Za-z]/)&&($st eq "array")) {	# 
		if ($stack[-2] eq "") {
			$global{$_} = "g[$global]";
			$global++;
		} else {
			synerr();
		}

	} elsif ((/[][]/)&&($st eq "array")) {		# 
		# do nothing

	} elsif ((/^[0-9]/)&&($st eq "array")) {	# 
		$code[$c++] = "ps\t$global";
		$code[$c++] = sprintf "pl\t&g[%d]", $global-1;
		$global += $_ + 1;

	} elsif (($_ eq "begin")&&($st eq "")) {	# ᥤ롼󳫻
		$code[$c++] = "_start";
		push @stack, $_;

	} elsif ($_ eq "begin") {			# ʣʸ
		push @stack, $_;

	} elsif ($_ eq "end") {				# ʣʸλ
		back(@allOp);
		$code[$c++] = pop @stack if ($stack[-1] =~ /\t|_/);
		checkCtrl();
		if ($stack[-1] eq "begin") {
			pop @stack;
		} else {
			synerr();
		}

	} elsif ($_ eq "if") {				# ifʸ
		push @stack, "\%$_";

	} elsif ($_ eq "then") {			# if-then
		back(@allOp);
		synerr() if ($stack[-1] ne "\%if");
		$stack[-1] = "\%then";
		$code[$c++] = "_pushlc";
		$code[$c++] = "_jf";

	} elsif ($_ eq "else") {			# if-then-else
		back(@allOp);
		$code[$c++] = pop @stack if ($stack[-1] =~ /\t|_/);
		synerr() if ($stack[-1] !~ /\%(if|then|else|do)$/);
		$stack[-1] = "\%else";
		$code[$c++] = "_pushlc";
		$code[$c++] = "_jp";
		$code[$c++] = "_exchange";
		$code[$c++] = "_popref";

	} elsif ($_ eq "while") {			# whileʸ
		push @stack, "\%$_";
		$code[$c++] = "_pushlc";
	
	} elsif ($_ eq "do") {				# while-do
		back(@allOp);
		synerr() if ($stack[-1] ne "\%while");
		$stack[-1] = "\%$_";
		$code[$c++] = "_pushlc";
		$code[$c++] = "_jf";

	} elsif ($_ eq "repeat") {			# repeatʸ
		$code[$c++] = "_pushlc";
		push @stack, "\%$_";

	} elsif ($_ eq "until") {			# repeat-until
		back(@allOp);
		$code[$c++] = pop @stack if ($stack[-1] =~ /\t|_/);
		checkCtrl();
		synerr() if ($stack[-1] ne "\%repeat");
		$stack[-1] = "\%$_";
		$code[$c++] = pop @stack if ($stack[-1] =~ /\t|_/);

	} elsif ($_ eq "return") {			# returnʸ
		push @stack, "\%retf";

	} elsif (/^(put|halt|get|inc|dec|puti|putiln)$/) { # ȹ߼³ؿ
		push @stack, "\@$_";

	} elsif (($_ eq ")")&&($st =~ /^'(.*)'$/)) {	# put̿
		$code[$c++] = "puts\t$1";
		pop @stack;
		pop @stack;
		pop @stack;

	} elsif (($_ eq ",")&&($st =~ /^'(.*)'$/)) {	# put̿
		$code[$c++] = "puts\t$1";
		pop @stack;

	} elsif (/^'(.*)'$/) {				# ʸ
		push @stack, $_;

	} elsif (($_ eq "(")&&($st eq "\@halt")) {	# halt̿
		# do nothing;

	} elsif (($_ eq ")")&&($st eq "\@halt")) {	# halt̿
		$code[$c++] = "halt";
		pop @stack;

	} elsif (($_ eq "(")&&($st eq "\@get")) {	# get̿
		# do nothing;

	} elsif (($_ eq ")")&&($st eq "\@get")) {	# get̿
		$code[$c++] = "get";
		pop @stack;

	} elsif (($_ eq "(")&&($st =~ /^\@(inc|dec)$/)) { # inc/decؿ
		# do nothing;

	} elsif ((/^[A-Za-z]/)&&($st eq "\@inc")) {	# incؿ
		if (defined $name{$_}) {
			$code[$c++] = "inc\t&$name{$_}";
		}

	} elsif ((/^[A-Za-z]/)&&($st eq "\@dec")) {	# decؿ
		if (defined $name{$_}) {
			$code[$c++] = "dec\t&$name{$_}";
		}

	} elsif (($_ eq ")")&&($st =~ /^\@(inc|dec)$/)) { # inc/decؿ
		pop @stack;

	} elsif (($_ eq "=")&&($st =~ /\t/)) {		# ʸ
		push @stack, $_;

	} elsif (($_ eq "=")&&($st =~ /^.\[/)) {	# ʸ
		pop @stack;
		push @stack, "pl\t&$st";
		push @stack, "=";

	} elsif ($_ eq ";") {				# ʸλ
		back(@allOp);
		$code[$c++] = pop @stack if ($stack[-1] =~ /\t|_/);
		checkCtrl();

	} elsif ($_ eq ",") {				# °Υ
		back(@allOp);
		if ($stack[-2] eq "\@put") {
			$code[$c++] = "put";
		}

	} elsif ($_ eq ":") {				# ط黻
		back(@allOp);
		push @stack, "eq"

	} elsif ($_ eq "#") {				# ط黻
		back(@allOp);
		push @stack, "ne"

	} elsif ($_ eq "<") {				# ط黻
		back(@allOp);
		push @stack, "lt"

	} elsif ($_ eq ">") {				# ط黻
		back(@allOp);
		push @stack, "gt"

	} elsif (($_ eq "--")&&($st eq "=")) {		# ñ黻
		$code[$c++] = "ps\t0";
		pop @stack;
		push @stack, "sub";

	} elsif (($_ eq "--")&&($st =~ /^[([]$/)) {	# ñ黻
		$code[$c++] = "ps\t0";
		push @stack, "sub";

	} elsif ($_ eq "+") {				# ˡ黻
		back("add", "sub", "or", "mul", "div", "mod", "and", "not");
		push @stack, "add";

	} elsif ($_ eq "-") {				# ˡ黻
		back("add", "sub", "or", "mul", "div", "mod", "and", "not");
		push @stack, "sub";

	} elsif ($_ eq "or") {				# ˡ黻
		back();
		push @stack, "or";

	} elsif ($_ eq "*") {				# ˡ黻
		back("mul", "div", "mod", "and", "not");
		push @stack, "mul";

	} elsif (/^(div|mod|and)$/) {			# ˡ黻
		back("mul", "div", "mod", "and", "not");
		push @stack, $_;

	} elsif ($_ eq "(") {				# 
		pop @stack if ($st eq "=");
		push @stack, $_;

	} elsif ($_ eq ")") {				# Ĥ
		back(@allOp);
		$st = pop @stack;
		my $s = $stack[-1];
		if ($st ne "(") {
			synerr();
		} elsif (grep {$_ eq $s} @allOp) {
			# do nothing;
		} elsif ($s eq "\@put") {
			$code[$c++] = "put";
			pop @stack;
		} elsif ($s eq "\@puti") {
			$code[$c++] = "puti";
			pop @stack;
		} elsif ($s eq "\@putiln") {
			$code[$c++] = "putiln";
			pop @stack;
		} elsif (($s =~ /^[A-Za-z]/)&&($s !~ /\t/)) {
			$code[$c++] = "_call\t$s";
			pop @stack;
		}

	} elsif ($_ eq "[") {				# γ
		push @stack, $_;

	} elsif ($_ eq "]") {				# γĤ
		back(@allOp);
		synerr() if (pop @stack ne "[");
		$st = pop @stack;
		if ($stack[-1] eq "begin") {
			push @stack, "plm\t$st";
		} elsif ($stack[-1] =~ /^\%(then|else|do|repeat)$/) {
			push @stack, "plm\t$st";
		} else {
			$code[$c++] = "psm\t$st";
		}

	} elsif (/^[0-9]+$/) {				# 
		push @stack, $_;

	} elsif (/^[A-Za-z][A-Za-z0-9]*$/) {		# ̻
		if (defined $name{$_}) {
			push @stack, $name{$_};
		} else {
			push @stack, $_;
		}

	} elsif (($_ eq ".")&&($st eq "")) {		# ץཪλ
		last;

	} elsif ($_ eq ".") {				# ץཪλ
		synerr();

	} else {					# 顼
		synerr();
	}
}

# 
foreach (@code) {
	print;
	print "\n" unless (/\n/);
}

#--------------------------------------------------------------------------#
# ʸˡ顼ٹ
sub synerr {
	warn "Syntax error at line $index.\n";
	warn $input[$index-1];
	$"="/"; warn "$index\[@stack]$_\n";
	exit 1;
}

#--------------------------------------------------------------------------#
# å
# : åξ夫2Ĥ᤬ʤݥåפȤ黻ҤΥꥹ
sub back {
	my @pat = @_;
	my $st = $stack[-1];
	$st = pop @stack if ($st eq "=");
	if ($st =~ /^[0-9]|^.\[/) {
		pop @stack;
		my $s = pop @stack;
		if ($s eq "=") {
			$code[$c++] = "ps\t$st";
		} elsif ($s =~ /^(\(|\[)$/) {
			$code[$c++] = "ps\t$st";
			push @stack, $s;
		} elsif ($s eq "not") {
			$code[$c++] = "ps\t$st";
			$code[$c++] = "not";
		} elsif (grep {$_ eq $s} @pat) {
			$code[$c++] = "$s\t$st";
		} else {
			$code[$c++] = "ps\t$st";
			push @stack, $s;
			return;
		}
	}
	while (grep {$_ eq $stack[-1]} @allOp) {
		my $s = pop @stack;
		if ($s eq "not") {
			$code[$c++] = "not";
		} else {
			$code[$c++] = "$s\tpop";
		}
	}
}

#--------------------------------------------------------------------------#
# ʸǤΥå
sub checkCtrl {
	while ($stack[-1] =~ /^\%/) {
		my $st = pop @stack;
		if ($st =~ /\%(then|else)/) {
			$code[$c++] = "_popref";
		} elsif ($st eq "\%do") {
			$code[$c++] = "_exchange";
			$code[$c++] = "_popdef&jp";
			$code[$c++] = "_popref";
		} elsif ($st eq "\%until") {
			$code[$c++] = "_popdef&jf";
		} elsif ($st eq "\%retf") {
			$code[$c++] = "retf";
		} elsif ($st eq "\%proc") {
			$code[$c++] = "retp";
			%name = %global;
			my $i;
			for ($i=@code-1; $i>=0; $i--) {
				if ($code[$i] eq $st) {
					$local--;
					$code[$i] = "proc\t$argsize\t$local";
						last;
				}
			}
		} elsif ($st eq "\%func") {
				$code[$c++] = "ps\t0";
			$code[$c++] = "retf";
			%name = %global;
			my $i;
			for ($i=@code-1; $i>=0; $i--) {
				if ($code[$i] eq $st) {
					$local--;
					$code[$i] = "func\t$argsize\t$local";
					last;
				}
			}
		} else {
			push @stack, $st;
			return;
		}
	}
}

