#!/usr/bin/perl -w
#
# MicroPlan2002Rxɥѥ
#
# (c) FukTommy<fuktommy@my.tramonline.net>
#
# 2002/05/19	ver.-.-.-
# 2002/05/21	ver.-.-.-	顼åSTDERR˽
# 2002/05/22	ver.-.-.-	Τ_endinit̿ɲ
# 2002/05/26	ver.0.0.1	
# 2002/05/26	ver.0.0.2	ѹʤ
# 2002/05/27	ver.0.0.3	ѹʤ
#

# ѿ
@input	= ();	# 
@code	= ();	# ΰ
@stack	= ();	# å
%name	= ();	# ̾ɽ
%def	= ();	# ̾Ѥɤɽ
$global	= 0;	# ǡΰΥ
$lc	= 1;	# ɥ

# ν
if (grep $_ eq "--help", @ARGV) {
	exec "cat $0";
} elsif (@ARGV == 0) {
	@input = <STDIN>;
} elsif (@ARGV == 1) {
	open IN, $ARGV[0];
	@input = <IN>;
	close IN;
} else {
	die "usage: $0 [Rx-code-file]\n";
}

# ɺ
$code[0] = "nop";
for ($i=0; $i<@input; $i++) {
	my $f = load($i);
	last if ($f);
}

# 
for ($i=0; $i<@code; $i++) {
	printf "%04d:\t%s\n", $i, $code[$i];
}

#--------------------------------------------------------------------------#
# ԤΥ
# : оݤιֹ
# : λɤ
sub load {
	my $i = $_[0];
	local $_ = $input[$i];
	s/\n//;
	s/^\s+//;
	local @_ = split;

	if (/^$/ || /^#/) {		# ԡȹ
                return;

	} elsif (/^[^_]/) {		# Qx
		$code[$lc++] = $_;

	} elsif ($_[0] eq "_array") {	# ̿
		$code[$lc++] = $global;	# 
		$global += $_[1];

	} elsif ($_[0] eq "_call") {	# ƤӽФ̿
		my $name = $_[1];
		if (defined $def{$name}) {
			$code[$lc++] = "call\t$name{$name}";
		} elsif (defined $name{$name}) {
			$code[$lc] = sprintf "call\t%d", $name{$name};
			$name{$name} = $lc++;
		} else {
			$code[$lc] = 0;
			$name{$name} = $lc++;
		}

	} elsif ($_[0] eq "_def") {	# ̿
		my $name = $_[1];
		if (defined $def{$name}) {
			die "Name '$name' is difined twice.\n";
		} elsif (defined $name{$name}) {
			my $t = $name{$name};
			$name{$name} = $lc;
			$def{$name} = 1;
			while ($t > 0) {
				($t, $code[$t]) =
				($code[$t], sprintf "call\t%d", $name{$name});
			}
		} else {
			$name{$name} = $lc;
			$def{$name} = 1;
		}

	} elsif ($_ eq "_pushlc") {	# pushlc̿
		push @stack, $lc;

	} elsif ($_ eq "_popref") {	# popref̿
		my $addr = pop @stack;
		local @_ = split /\s+/, $code[$addr];
		$code[$addr] = sprintf "%s\t%d", $_[0], $lc;

	} elsif ($_ eq "_popdef&jp") {	# popdef&jp̿
		my $addr = pop @stack;
		$code[$lc++] = sprintf "%s\t%d", "jp", $addr;

	} elsif ($_ eq "_popdef&jf") {	# popdef&jf̿
		my $addr = pop @stack;
		$code[$lc++] = sprintf "%s\t%d", "jf", $addr;

	} elsif ($_ eq "_jp") {		# jp̿
		$code[$lc++] = sprintf "%s\t%d", "jp", 0;

	} elsif ($_ eq "_jf") {		# jf̿
		$code[$lc++] = sprintf "%s\t%d", "jf", 0;

	} elsif ($_ eq "_exchange") {	# exchange̿
		($stack[$#stack], $stack[$#stack-1]) =
		($stack[$#stack-1], $stack[$#stack]);

	} elsif ($_ eq "_start") {	# ¹Գ̿
		my $f = 0;
		foreach (@code) {
			if ($_ eq "end_of_init") {
				$_ = "jp\t$lc";
				$f = 1;
				last;
			}
		}
		$code[0] = "jp\t$lc" unless ($f);

	} elsif ($_ eq "_endinit") {	# ɽλ̿
		$code[$lc++] = "end_of_init";

	} elsif ($_ eq "_exit") {	# ｪλ
		my ($name, $addr);
		while (($name, $addr) = each %name) {
			unless (defined $def{$name}) {
				die "Name '$name' is not defined.\n";
			}
		}
		return 1;

	} elsif ($_[0] eq "_die") {	# ۾ｪλ
		warn "$_[1]\n";
		exit 1;

        } else {			# 顼
		printf STDERR "Syntax error at line %d.\n", $i;
		print STDERR "$_\n";
		exit 1;
        }

	return 0;
}
